//+------------------------------------------------------------------+
//|                              (GBD|USD H4)    Stochastic v1.1.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                                  kgranit@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "kgranit@ukr.net"
#define MAGICMA  20050610

extern double Lots = 1;
extern double TrailingStop = 14;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {

   return(0);
  }
 

  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double StochasticGreen;  
   double StochasticRed; 

   
   int cnt, ticket, total;
  
  StochasticGreen=iCustom(NULL, 0, "Stochastic",6,15,5, 0, 1);
  StochasticRed=iCustom(NULL, 0, "Stochastic",6,15,5, 1, 1);  

    
  total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(700*Lots))
        {
         Print("   . Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // check for long position (BUY) possibility
      if((StochasticGreen>StochasticRed))
        {
        ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"kosta",16384,0,Green);
        }
      // check for short position (SELL) possibility && (TriggerLines1>TriggerLines0)
      if((StochasticGreen<StochasticRed))
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"kosta",16384,0,Red);
        } 
     }
// it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if((StochasticGreen<StochasticRed))
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if((StochasticGreen>StochasticRed))
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.